var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

var Background1ButtonArea = [-7, -7, 366, 367];
var Digitalclock2BitmapStrImages = [];
var Digitalclock2BitmapStrKey = ["am", "pm"];
var Digitalclock2BitmapStr = ["", ""];
var Digitalclock2Images = [];
var Digitalclock2Bitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var imgp2png = new Image();
var imgp2png = new Image();
var imgp1png = new Image();
var imghpng = new Image();
var imgmpng = new Image();
var imgspng = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    gImage.src = "bg.png";
    context.drawImage(imgbgpng, -7, -7, 373, 374);
    context.restore();
    context.save();

    context.translate(273, 273);
    context.rotate(45.0*Math.PI/180);
    context.beginPath();
    context.font = "bold 20px Tizen";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = date.getDate();
    context.fillText(text, 0, 0);
    context.restore();
    context.save();

    text = date.getDay();
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<Digitalclock2BitmapStr.length; j++) {
                if (tokens[i] === Digitalclock2BitmapStrKey[j]) {
                    charImage = Digitalclock2BitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (Digitalclock2Bitmap[strChar - 0x20] !== "") {
                            charImage = Digitalclock2Images[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 180 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 180 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    angle = (0.000000 + ((360.000000 - 0.000000) * ((Math.floor(battery.level*100) - 0.000000) / (100.000000 - 0.000000))))*Math.PI/180;
    context.translate(118, 140);
    context.rotate(angle);
    imgp2png.src = "p2.png";
    context.drawImage(imgp2png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = null
    context.translate(118, 240);
    context.rotate(angle);
    imgp2png.src = "p2.png";
    context.drawImage(imgp2png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = null
    context.translate(118, 240);
    context.rotate(angle);
    imgp1png.src = "p1.png";
    context.drawImage(imgp1png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imghpng.src = "h.png";
    context.drawImage(imghpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgmpng.src = "m.png";
    context.drawImage(imgmpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((seconds - 0.000000) / (60.000000 - 0.000000))) + (frame < 3 ? (frame == 0 ? 0.300000 : (0.300000 * (3 - frame)/3)) : 0))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgspng.src = "s.png";
    context.drawImage(imgspng, -180, -180, 360, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

    var i;
    for (i = 0; i<95; i++) {
        if (Digitalclock2Bitmap[i] !== "") {
            Digitalclock2Images[i] = new Image();
            Digitalclock2Images[i].src = "res/fonts/bitmap_0/" + Digitalclock2Bitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (Digitalclock2BitmapStr[i] !== "") {
            Digitalclock2BitmapStrImages[i] = new Image();
            Digitalclock2BitmapStrImages[i].src = "res/fonts/bitmap_0/" + Digitalclock2BitmapStr[i];
        }
    }
    window.addEventListener('touchstart', function (e) {
        if (e.changedTouches[0].clientX >= Background1ButtonArea[0] && e.changedTouches[0].clientX < Background1ButtonArea[2] && e.changedTouches[0].clientY >= Background1ButtonArea[1] && e.changedTouches[0].clientY < Background1ButtonArea[3]) {
            tizen.application.launch("com.samsung.clocksetting");
        }
    });
};
